import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;

import static org.junit.jupiter.api.Assertions.assertTrue;

public class StoreTest {

    private TradingDeal tradingDeal;
    private Cards newCards, cards, nochNewCards;
    private Card newCard, card;
    private ArrayList<Card> cardsArrayList, cardsArrayList2, cardsArrayList3;
    private Stack stack;
    private User user, userNew;
    private Store store;

    @BeforeEach
    void setUp() {
        //Stack
        card = new Card("Name", 10, ElementTyp.WATER, CardType.MONSTER);
        newCard = new Card("NameNew", 10, ElementTyp.WATER, CardType.SPELL);
        cardsArrayList = new ArrayList<Card>();
        cardsArrayList2 = new ArrayList<Card>();
        cardsArrayList3 = new ArrayList<Card>();
        cardsArrayList.add(card);
        cardsArrayList2.add(newCard);
        cards = new Cards(cardsArrayList);
        newCards = new Cards(cardsArrayList2);
        nochNewCards = new Cards(cardsArrayList3);
        stack = new Stack(cards, nochNewCards);

        //Coins
        Coins coins = new Coins(10);
        //User
        Credentials credentials = new Credentials();
        user = new User(credentials, "name", "nachname", "email", stack, coins);
        userNew = new User(credentials, "nameNew", "nachnameNew", "emailNew", stack, coins);

        //Trading Deal
        Card cardToTrade = card;
        ElementTyp requiredElementType = ElementTyp.FIRE;
        double requiredMinDamage = 100;
        CardType requiredCardType = CardType.MONSTER;
        tradingDeal = new TradingDeal(user, cardToTrade, requiredElementType, requiredMinDamage, requiredCardType);

    }

    @Test
    void test_addTradingDeal() {
        user.addTradingDeal(tradingDeal);
        ArrayList<TradingDeal> expected = new ArrayList<TradingDeal>();
        expected.add(tradingDeal);
        assertTrue(user.getTradingDeals() == expected);
    }
    @Test
    void test_doTrade() {
        boolean result = user.doTrading(tradingDeal, tradingDeal);
        assertTrue(result);
    }
    @Test
    void test_getTradingDeals() {
        ArrayList<TradingDeal> result = user.getTradingDeals();
        ArrayList<TradingDeal> expected = new ArrayList<TradingDeal>();
        expected.add(tradingDeal);
        assertTrue(result == expected);
    }
    @Test
    void test_getPossibleTradingDeals() {
        ArrayList<TradingDeal> result = user.getPossibleTradingDeals();
        ArrayList<TradingDeal> expected = new ArrayList<TradingDeal>();
        expected.add(tradingDeal);
        assertTrue(result == expected);
    }
    @Test
    void test_getAvailableTradingDeals() {
        ArrayList<TradingDeal> result = user.getPossibleAvailableTradingDeals();
        ArrayList<TradingDeal> expected = new ArrayList<TradingDeal>();
        expected.add(tradingDeal);
        assertTrue(result == expected);
    }
}
